package de.mbohlen.tools.jpresenter;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;

public class Presentation
{
    private ArrayList slides = new ArrayList();

    /**
     * Adds a new slide to the presentation.
     * @param slide the slide
     */
    public void addSlide(Slide slide)
    {
        slides.add(slide);
    }

    /**
     * Gets the slides for this presentation.
     * @return List the list of slides
     */
    public List getSlides()
    {
        return slides;
    }


    public static Presentation unzipPresentation(File zipFile)
    {
        return readContentDirectory(zipFile);
    }

    public static Presentation readContentDirectory(File zipFile)
    {
        PresentationHandler ph = new PresentationHandler();

        try
        {
            InputStream tempIStream =
                ZipUtils.loadEntryFromZip(zipFile, "contents.xml");
            SAXParserFactory spf = SAXParserFactory.newInstance();
            spf.setNamespaceAware(true);

            SAXParser sp = spf.newSAXParser();
            sp.parse(tempIStream, ph);
            tempIStream.close();
        }
        catch (ParserConfigurationException e)
        {
            e.printStackTrace();
        }
        catch (SAXException e)
        {
            e.printStackTrace();
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }

        return ph.getPresentation();
    }

}
