package de.mbohlen.tools.jpresenter;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.zip.ZipFile;

public class ZipUtils
{
    public static InputStream loadEntryFromZip(
        File zipFile,
        String entryName) throws IOException
    {
        ZipFile zip = new ZipFile(zipFile);
        InputStream is = zip.getInputStream(zip.getEntry(entryName));
        
        // The InputStream returned by ZipFile.getInputStream
        // does not support mark() or reset(), which unfortunately
        // is required by JavaSound.
        
        // So, what we do here is: copy the bytes from the stream
        // into memory and return an input stream on that memory.
        
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        byte ba[] = new byte[1024];
        int count;
        while ( (count = is.read(ba)) > 0 )
        {
            baos.write(ba, 0, count);
        }
        is.close();
        baos.close();
 
        return new ByteArrayInputStream(baos.toByteArray());
    }
}
